#ifndef __GDIP_UTIL_H__
#define __GDIP_UTIL_H__

CLSID        Get_Mime_Type(char *p);
int          GetEncoderClsid(const WCHAR* format, CLSID* pClsid);

// gq CLSID 擾
CLSID Get_Mime_Type(char *p)
{
	CLSID Clsid;
	
	if(!stricmp(p,"bmp")){
		GetEncoderClsid(L"image/bmp",&Clsid);
	}
	else if(!stricmp(p,"gif")){
		GetEncoderClsid(L"image/gif",&Clsid);
	}
	else if(!stricmp(p,"jpg") || !stricmp(p,"jpeg")){
		GetEncoderClsid(L"image/jpeg",&Clsid);
	}
	else if(!stricmp(p,"png")){
		GetEncoderClsid(L"image/png",&Clsid);
	}
	else if(!stricmp(p,"tif") || !stricmp(p,"tiff")){
		GetEncoderClsid(L"image/tiff",&Clsid);
	}
	else{
		GetEncoderClsid(L"image/bmp",&Clsid);
		MessageBox(NULL,"rbg}bv`ŕۑ܂","",MB_OK | MB_ICONWARNING);
	}
	
	return (Clsid);

}// Get_Mime_Type

// MIMECLSID擾
int GetEncoderClsid(const WCHAR* format, CLSID* pClsid)
{
	UINT num  = 0; // number of image encoders
	UINT size = 0; // size of the image encoder array in bytes
	
	ImageCodecInfo* pImageCodecInfo = NULL;
	
	GetImageEncodersSize(&num, &size);
	if(size == 0)
		return -1; // Failure
	
	pImageCodecInfo = (ImageCodecInfo*)(malloc(size));
	if(pImageCodecInfo == NULL)
		return -1; // Failure
	
	GetImageEncoders(num, size, pImageCodecInfo);
	
	for(UINT j = 0; j < num; ++j)
	{
		if( wcscmp(pImageCodecInfo[j].MimeType, format) == 0 )
		{
			*pClsid = pImageCodecInfo[j].Clsid;
			free(pImageCodecInfo);
			return j; // Success
		}
	}
	
	free(pImageCodecInfo);
	return -1; // Failure
}// GetEncoderClsid

#endif // __GDIP_UTIL_H__
